Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const react_apollo_1 = require("react-apollo");
exports.QueryUntil = (props) => {
    const { data: prev, query, variables, merge, getNextCursor, cursorProp, children } = props;
    return (React.createElement(react_apollo_1.Query, { query: query, variables: variables }, (context) => {
        const { data, loading } = context;
        if (!loading && data) {
            const cursor = getNextCursor(data);
            if (cursor) {
                return (React.createElement(exports.QueryUntil, { query: query, variables: Object.assign({}, variables, { [cursorProp]: cursor }), data: merge(prev, data), getNextCursor: getNextCursor, merge: merge }, children));
            }
            return children(Object.assign({}, context, { data: merge(prev, data) }));
        }
        return children(Object.assign({}, context, { data: prev }));
    }));
};
exports.QueryUntil.defaultProps = {
    cursorProp: 'cursor',
    variables: {
        [this.cursorProp]: null,
    }
};
